// Vertex Shader  file "shadername.vert"

#version 330

// Incoming per vertex... position and normal
in vec4 vVertex;
in vec3 vNormal;
in vec2 vTexCoord;

uniform mat4   mMatrix;
uniform mat4   mvpMatrix;
uniform mat4   mvMatrix;
uniform mat3   normalMatrix;
uniform vec3   vLightPosition;
uniform int    useLight;
uniform mat4   texMatrix;

// Color to fragment program
out vec3 vVaryingNormal;
out vec2 vVaryingTexCoords;
out vec3 vVaryingPosition;
out vec4 vVaryingTexCoordsProj;
//out vec3 vVaryingRandom;
//out vec3 vVaryingLightDir;

void main(void)
{
    	//projective texture hints:
	//vertex shader:
		//tex_mat = MT * MS * Plight * Vlight
		//SM_tex_coord = tex_mat * M * vertex;
	// Get surface normal in eye coordinates

    vVaryingNormal = normalize(normalMatrix * vNormal);
	    
	// Get vertex position in eye coordinates
    //vec4 vPosition4 = mvMatrix * vVertex;
	//vec4 vPosition4 = mMatrix * vVertex;
    //vec3 vPosition3 = vPosition4.xyz / vPosition4.w;

    // Get vector to light source
    //vVaryingLightDir = normalize(vLightPosition - vPosition3);

    vVaryingTexCoords = vTexCoord;
	vVaryingPosition = vec3(mvMatrix * vVertex);
	//vVaryingRandom.r = fract(sin(dot(vVaryingPosition.xy ,vec2(12.9898,78.233))) * 43758.5453);
	//vVaryingRandom.g = fract(sin(dot(vVaryingPosition.xz ,vec2(12.9898,78.233))) * 43758.5453);
	//vVaryingRandom.b = fract(sin(dot(vVaryingPosition.yz ,vec2(12.9898,78.233))) * 43758.5453);
	//vVaryingRandom = vRandom * vVertex.xyz;
	vVaryingTexCoordsProj = texMatrix * mMatrix * vVertex;
	// Don't forget to transform the geometry!
    gl_Position = mvpMatrix * vVertex;
}



